/*****************************************************************************
*
* Atmel Corporation
*
* ̧			: g72x.h
* ߲		: Microsoft Visual C++ 6.0
* 			: $Revision: 1.3 $
* t			: $Date: Thursday, September 23, 2004 13:21:18 UTC $
* XV		: $Author: kmeyer $
*
* xҰ		: avr@atmel.com
*
* x޲	: ATmega128/Windows PC (ANSICׂ߲̉\
*				  )
*
* pLq		: AVR336: ADPCM
*
* 			: ADPCMpͯ ̧فB͉pLqԍ336:ADPCM
*				  ɑ΂⑫łB͂̕p̕ް𐶐
*				  ̂ɕKvƂ܂B
*
*				  ĳ̈ꕔSun Microsystem, Inc.ɂČ̏ɌJꂽ
*				  ނɊ܂B
*
****************************************************************************/
/*
 * ̿ ނSun Microsystems, Inc.̐iŖ̎gpɑ΂ċĂ
 * ܂Bgp҂͑㉿Ȃɂ̿ ނ𕡎ʂ܂͕ύXł܂B
 *
 * Sun̿ ނ͐݌vAsꐫA̖ړIɑ΂KA܂͎Agp@
 * Ɩ̐isNۏ؂܂߂āAǂ̎̕ۏ؂SȂA󂻂̂܂܂Œ
 * ܂B
 *
 * Sun̿ ނ͂̎gpACAύX܂͋ɉ鉇ɑ΂
 * Sun Microsystems, Inc.̈ꕔɉĂǂȐӖȂSxȂŒ񋟂
 * B
 *
 * Sun Microsystems, Inc.͂̿ĳ܂͂̉ꂩ̕ɂĒ쌠A
 * ̔閧A܂͉ꂩ̓̐NQɊւđSӔCȂł傤B
 *
 * ႦSun̂悤ȑQ̉\̐iĂƂĂASun Microsystems,
 * Inc.͂ǂȎꂽ◘vA܂͑̓ʂŁAԐړIŊKRIȑQ
 * ɂāAx̋`Ȃł傤
 *
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */

/*
 * g72x.h
 *
 * CCITTϊٰݗpͯ ̧
 *
 */
#ifndef _G72X_H
#define	_G72X_H

#define	AUDIO_ENCODING_ULAW		(1)		/* ISDN -law */
#define	AUDIO_ENCODING_ALAW		(2)		/* ISDN A-law */
#define	AUDIO_ENCODING_LINEAR	(3)		/* PCM 2̕␔ (0S) */

/*
 * ȉ͘AIȌĂяo̊Ԃɂ̓Ԃێ邽߂G.726
 * ɂĎgpԍ\̂̒`łBԍ\̂̑命̈ӖITU-
 * TG.726ŏڍׂɐĂ܂B̈於͂̐Ɋ܂܂镄Z@
 *  ًLqł̕ϐƖ{IɓłB
 */

struct g72x_state {
	long yl;		/* Œ艻܂͕sς̏ԒiKʔ{ */
	short yu;		/* Œ艻܂͕ω̏ԒiKʔ{ */
	short dms;		/* ZԴٷްς */
	short dml;		/* Դٷްς */
	short ap;		/* 'yl''yu'̒d݌W */

	short a[2];		/* \zhg̋ɕ̌W */
	short b[6];		/* \zhg̗_̌W */
	short pk[2];	/* Iȍč\M̒O2̕ */
	short dq[6];	/* _`ŕ\ʎqM̒O6 */
	short sr[2];	/* _`ŕ\ʎqM̒O2 */
	char td;		/* xo(1988ł̐V) */
};

/* O֐` */

extern void g72x_init_state(struct g72x_state *);
extern int g726_32_encoder(
		int sample,
		int in_coding,
		struct g72x_state *state_ptr);
extern int g726_32_decoder(
		int code,
		int out_coding,
		struct g72x_state *state_ptr);
extern int g726_24_encoder(
		int sample,
		int in_coding,
		struct g72x_state *state_ptr);
extern int g726_24_decoder(
		int code,
		int out_coding,
		struct g72x_state *state_ptr);
extern int g726_40_encoder(
		int sample,
		int in_coding,
		struct g72x_state *state_ptr);
extern int g726_40_decoder(
		int code,
		int out_coding,
		struct g72x_state *state_ptr);

extern int g726_16_encoder(
		int sample,
		int in_coding,
		struct g72x_state *state_ptr);
extern int g726_16_decoder(
		int code,
		int out_coding,
		struct g72x_state *state_ptr);

extern short predictor(short *sez, struct g72x_state *state_ptr);
extern int step_size(struct g72x_state *state_ptr);
extern unsigned char linear2alaw(int pcm_val);
extern int alaw2linear(unsigned char a_val);
extern int ulaw2linear(unsigned char u_val);
extern unsigned char linear2ulaw(int pcm_val);
extern int quantize(int d, int y, short *table, int size);
extern int reconstruct(int sign, int dqln, int y);
extern void update(int code_size, int y, int wi, int fi, int dq, int sr,
                   int dqsez, struct g72x_state *state_ptr);
extern int tandem_adjust_ulaw(int sr, int se, int y, int i, int	sign, 
							  short	*qtab);
extern int tandem_adjust_alaw(int sr, int se, int y, int i, int	sign, 
							  short	*qtab);

#endif /* !_G72X_H */
