/*****************************************************************************
*
* Atmel Corporation
*
* ̧			: g711.c
* ߲		: Microsoft Visual C++ 6.0
* 			: $Revision: 1.3 $
* t			: $Date: Thursday, September 23, 2004 13:20:56 UTC $
* XV		: $Author: kmeyer $
*
* xҰ		: avr@atmel.com
*
* x޲	: ATmega128/Windows PC (ANSICׂ߲̉\
*				  )
*
* pLq		: AVR336: ADPCM
*
* 			: ADPCMp̃-law/A-law/PCMϊٰ݁B͉p
*				  Lqԍ336:ADPCMɑ΂⑫łB͂̕p
*				  ް𐶐̂ɕKvƂ܂B
*
*				  ĳ̈ꕔSun Microsystem, Inc.ɂČ̏ɌJꂽ
*				  ނɊ܂B
*
****************************************************************************/
/*
 * ̿ ނSun Microsystems, Inc.̐iŖ̎gpɑ΂ċĂ
 * ܂Bgp҂͑㉿Ȃɂ̿ ނ𕡎ʂ܂͕ύXł܂B
 *
 * Sun̿ ނ͐݌vAsꐫA̖ړIɑ΂KA܂͎Agp@
 * Ɩ̐isNۏ؂܂߂āAǂ̎̕ۏ؂SȂA󂻂̂܂܂Œ
 * ܂B
 *
 * Sun̿ ނ͂̎gpACAύX܂͋ɉ鉇ɑ΂
 * Sun Microsystems, Inc.̈ꕔɉĂǂȐӖȂSxȂŒ񋟂
 * B
 *
 * Sun Microsystems, Inc.͂̿ĳ܂͂̉ꂩ̕ɂĒ쌠A
 * ̔閧A܂͉ꂩ̓̐NQɊւđSӔCȂł傤B
 *
 * ႦSun̂悤ȑQ̉\̐iĂƂĂASun Microsystems,
 * Inc.͂ǂȎꂽ◘vA܂͑̓ʂŁAԐړIŊKRIȑQ
 * ɂāAx̋`Ȃł傤
 *
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */

/*
 * g711.c
 *
 * -lawAA-lawAPCMϊ
 */
#define	SIGN_BIT	(0x80)	/* A-law޲ėpޯ */
#define	QUANT_MASK	(0xf)	/* ʎq̈Օl */
#define	NSEGS		(8)		/* A-law敪 */
#define	SEG_SHIFT	(4)		/* 敪ԍpړ */
#define	SEG_MASK	(0x70)	/* 敪̈Օl */

static short seg_end[8] = {0xFF, 0x1FF, 0x3FF, 0x7FF,
						   0xFFF, 0x1FFF, 0x3FFF, 0x7FFF};

/* CCITT G.711dl畡 */
unsigned char _u2a[128] = {				/* -lawA-lawϊ */
	  1,   1,   2,   2,   3,   3,   4,   4,
	  5,   5,   6,   6,   7,   7,   8,   8,
	  9,  10,  11,  12,  13,  14,  15,  16,
	 17,  18,  19,  20,  21,  22,  23,  24,
	 25,  27,  29,  31,  33,  34,  35,  36,
	 37,  38,  39,  40,  41,  42,  43,  44,
	 46,  48,  49,  50,  51,  52,  53,  54,
	 55,  56,  57,  58,  59,  60,  61,  62,
	 64,  65,  66,  67,  68,  69,  70,  71,
	 72,  73,  74,  75,  76,  77,  78,  79,
	 81,  82,  83,  84,  85,  86,  87,  88,
	 89,  90,  91,  92,  93,  94,  95,  96,
	 97,  98,  99, 100, 101, 102, 103, 104,
	105, 106, 107, 108, 109, 110, 111, 112,
	113, 114, 115, 116, 117, 118, 119, 120,
	121, 122, 123, 124, 125, 126, 127, 128};

unsigned char _a2u[128] = {			/* A-law˃-lawϊ */
	  1,   3,   5,   7,   9,  11,  13,  15,
	 16,  17,  18,  19,  20,  21,  22,  23,
	 24,  25,  26,  27,  28,  29,  30,  31,
	 32,  32,  33,  33,  34,  34,  35,  35,
	 36,  37,  38,  39,  40,  41,  42,  43,
	 44,  45,  46,  47,  48,  48,  49,  49,
	 50,  51,  52,  53,  54,  55,  56,  57,
	 58,  59,  60,  61,  62,  63,  64,  64,
	 65,  66,  67,  68,  69,  70,  71,  72,
	 73,  74,  75,  76,  77,  78,  79,  79,
	 80,  81,  82,  83,  84,  85,  86,  87,
	 88,  89,  90,  91,  92,  93,  94,  95,
	 96,  97,  98,  99, 100, 101, 102, 103,
	104, 105, 106, 107, 108, 109, 110, 111,
	112, 113, 114, 115, 116, 117, 118, 119,
	120, 121, 122, 123, 124, 125, 126, 127};

static int
search(
	int val,
	short *table,
	int size)
{
	int i;

	for (i = 0; i < size; i++) {
		if (val <= *table++)
			return (i);
	}
	return (size);
}

/*
 * linear2alaw() - 16ޯĒPCMl8ޯA-lawϊ
 *
 * linear2alaw()16ޯĐ󂯓ĂA-lawްƂĕ܂B
 *
 *	͕	k
 *	------------	------------
 *	0000000wxyza	000wxyz
 *	0000001wxyza	001wxyz
 *	000001wxyzab	010wxyz
 *	00001wxyzabc	011wxyz
 *	0001wxyzabcd	100wxyz
 *	001wxyzabcde	101wxyz
 *	01wxyzabcdef	110wxyz
 *	1wxyzabcdefg	111wxyz
 *
 * XȂɂĂ1982NJohn Wiley & SonśuJohn C. Bellamy's Digital
 * Telephonyv98111472`476łB
 */
unsigned char
linear2alaw(
	int pcm_val)			/* 2̕␔(16ޯĔ͈) */
{
	int mask;
	int seg;
	unsigned char aval;

	if (pcm_val >= 0) {
		mask = 0xD5;		/* (7)ޯ=1 */
	} else {
		mask = 0x55;		/* ޯ=0 */
		pcm_val = -pcm_val - 8;
	}
	seg = search(pcm_val, seg_end, 8);		/* ړxꂽ傫敪ԍɕϊ */
	/* A敪AʎqޯČ */
	if (seg >= 8)							/* ͈͊OAőlԂ܂B */
		return (0x7F ^ mask);
	else {
		aval = seg << SEG_SHIFT;
		if (seg < 2)
			aval |= (pcm_val >> 4) & QUANT_MASK;
		else
			aval |= (pcm_val >> (seg + 3)) & QUANT_MASK;
		return (aval ^ mask);
	}
}

/*
 * alaw2linear() - A-lawl16ޯĒPCMɕϊ
 */
int
alaw2linear(
	unsigned char a_val)
{
	int t;
	int seg;

	a_val ^= 0x55;

	t = (a_val & QUANT_MASK) << 4;
	seg = ((unsigned)a_val & SEG_MASK) >> SEG_SHIFT;
	switch (seg) {
	case 0:
		t += 8;
		break;
	case 1:
		t += 0x108;
		break;
	default:
		t += 0x108;
		t <<= seg - 1;
	}
	return ((a_val & SIGN_BIT) ? t : -t);
}

#define	BIAS		(0x84)		/* p΂ */

/*
 * linear2ulaw() - PCMl-lawɕϊ
 *
 * ȒP邽߂ɁA̒̑傫33邱Ƃɂĕ΂炳
 * āA͈͂(0`8158)(33`8191)Ɉړ܂Bʂ͈ȉ̕\
 * Ō邱Ƃł܂B
 *
 *	΂炳ꂽ͕	kꂽ
 *	----------------------	--------------
 *	00000001wxyza			000wxyz
 *	0000001wxyzab			001wxyz
 *	000001wxyzabc			010wxyz
 *	00001wxyzabcd			011wxyz
 *	0001wxyzabcde			100wxyz
 *	001wxyzabcdef			101wxyz
 *	01wxyzabcdefg			110wxyz
 *	1wxyzabcdefgh			111wxyz
 *
 * ΂炳ꂽ̊eX͋敪ԍʂs1܂B敪ԍ
 * l7-s0̐ɓlłBʎqԊu4ޯĂwxyzƂĒڗp\
 * łBsޯ(a`h)͖܂B
 *
 * ʏAʕ̕␔MɎgpÂɕ͂ꂪԂOɕ␔
 * ܂B
 *
 * XȂɂĂ1982NJohn Wiley & SonśuJohn C. Bellamy's Digital
 * Telephonyv98111472`476łB
 */
unsigned char
linear2ulaw(
	int pcm_val)			/* 2̕␔(16ޯĔ͈) */
{
	int mask;
	int seg;
	unsigned char uval;

	/* l̕Ƒ傫擾 */
	if (pcm_val < 0) {
		pcm_val = BIAS - pcm_val;
		mask = 0x7F;
	} else {
		pcm_val += BIAS;
		mask = 0xFF;
	}

	seg = search(pcm_val, seg_end, 8);		/* ړxꂽ傫敪ԍɕϊ */

	/*
	 * A敪AʎqޯĂāA̕␔擾
	 */
	if (seg >= 8)							/* ͈͊OAőlԂ܂B */
		return (0x7F ^ mask);
	else {
		uval = (seg << 4) | ((pcm_val >> (seg + 3)) & 0xF);
		return (uval ^ mask);
	}
}

/*
 * ulaw2linear() - -lawl16ޯĒPCMɕϊ
 *
 * ŏɁA΂炳ꂽꂩ瓱o܂Bĕ΂炳ꂽ
 * 33Z邱ɂĕ΂炳ĂȂo͂𓾂邱Ƃł܂B
 *
 * ̊֐̕̕␔n邱Ƃ҂Ă邱ƂɒӂĂB
 * ISDNێłB
 */
int
ulaw2linear(
	unsigned char	u_val)
{
	int t;

	u_val = ~u_val;			/* W()-lawl𓾂邽߂ɕ␔擾 */

	/*
	 * ʎqޯĂ𒊏oĕ΂点܂Bċ敪ԍɂďֈړĕ΂
	 * ĊO܂B
	 */
	t = ((u_val & QUANT_MASK) << 3) + BIAS;
	t <<= ((unsigned)u_val & SEG_MASK) >> SEG_SHIFT;

	return ((u_val & SIGN_BIT) ? (BIAS - t) : (t - BIAS));
}

/* A-law-lawɕϊ */
unsigned char
alaw2ulaw(
	unsigned char	aval)
{
	aval &= 0xff;
	return ((aval & 0x80) ? (0xFF ^ _a2u[aval ^ 0xD5]) :
			(0x7F ^ _a2u[aval ^ 0x55]));
}

/* -lawA-lawɕϊ */
unsigned char
ulaw2alaw(
	unsigned char	uval)
{
	uval &= 0xff;
	return ((uval & 0x80) ? (0xD5 ^ (_u2a[0xFF ^ uval] - 1)) :
			(0x55 ^ (_u2a[0x7F ^ uval] - 1)));
}
